#define vmr	vmr_		/* parameter for Name Translation is l_ */
#define ROUTINE int
/*===========================================================================
  Copyright (C) 1995 European Southern Observatory (ESO)
 
  This program is free software; you can redistribute it and/or 
  modify it under the terms of the GNU General Public License as 
  published by the Free Software Foundation; either version 2 of 
  the License, or (at your option) any later version.
 
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public 
  License along with this program; if not, write to the Free 
  Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
  MA 02139, USA.
 
  Corresponding concerning ESO-MIDAS should be addressed as follows:
	Internet e-mail: midas@eso.org
	Postal address: European Southern Observatory
			Data Management Division 
			Karl-Schwarzschild-Strasse 2
			D 85748 Garching bei Muenchen 
			GERMANY
===========================================================================*/

/*++++++++++++++++++++++++  GENFTOCA.FC  +++++++++++++++++++++++++++++++++++
.LANGUAGE C
.IDENTIFICATION Module GENFTOCA.FC
.COMMENTS
Contains GENCNV, GENNUM, GENLGN, GENTIM
.AUTHOR         K. Banse  	ESO - Garching
.KEYWORDS       tools
.ENVIRONMENT    FORTRAN and C standards
.VERSION  [1.00] 880414:  created 
.VERSION  [3.00] 901213:  Master file. CG.
.VERSION  [3.10] 920507:  Extracted from genftoc.fc, KB
-----------------------------------------------------------------------------*/

#include <ftoc.h>
#include <midas_def.h>



static char savtext[160];
static int  savtype, savmaxval;

#if 0     /* ==== Original Code ==== */
SUBROUTINE STGG1(text,type,maxval)
CHARACTER   text;       /* IN: input line */
fint2c  *type;          /* IN: = 1, for integer; = 2, for real; = 4, doubl pre*/
fint2c  *maxval;        /* IN: maximal no. of output values */
#else     /* ==== Generated Code === */
#define STGG1	stgg1_
STGG1(va_alist) va_dcl 
{ va_list Cargs;
#endif    /* ======================= */
  int FORmark;           /* <forif> */
  va_start(Cargs);       /* <forif> */
  FORmark = ftoc_mark(); /* <forif> */

strncpy(savtext,STRIPPED_STRING(1,3,0),159);
savtext[159] = '\0';

savtype = *PARAM(2,3,1,fint2c *);
savmaxval = *PARAM(3,3,1,fint2c *);
  ftoc_free(FORmark);    /* <forif> */
}

#if 0     /* ==== Original Code ==== */
SUBROUTINE STGG2(ibuf,rbuf,dbuf,actvals)
fint2c  *ibuf;          /* OUT: integer output buffer */
float   *rbuf;          /* OUT: real output buffer */
double  *dbuf;          /* OUT: double precision output buffer */
fint2c  *actvals;
#else     /* ==== Generated Code === */
#define STGG2	stgg2_
STGG2(va_alist) va_dcl 
{ va_list Cargs;
#endif    /* ======================= */
  va_start(Cargs);       /* <forif> */

*PARAM(4,4,0,fint2c *) = CGN_CNVT(savtext,savtype,savmaxval,PARAM(1,4,0,fint2c *),PARAM(2,4,0,float *),PARAM(3,4,0,double *));
}

#if 0     /* ==== Original Code ==== */
SUBROUTINE STGG3(size,imno,cloned,status)
fint2c  *size;          /* IN: = size of new image */
fint2c  *imno;          /* OUT: = image id of new image */
fint2c  *cloned;        /* OUT: =1 if descr's were cloned, else =0 */
fint2c *status;
#else     /* ==== Generated Code === */
#define STGG3	stgg3_
STGG3(va_alist) va_dcl 
{ va_list Cargs;
#endif    /* ======================= */


/* name -> savtext, simno -> savtype, datform -> savmaxval  */  va_start(Cargs);       /* <forif> */


*PARAM(4,4,0,fint2c *) = CGN_IBUILD(savtype,savtext,savmaxval,*PARAM(1,4,0,fint2c *),PARAM(2,4,0,fint2c *),PARAM(3,4,0,fint2c *));
}

#if 0     /* ==== Original Code ==== */
SUBROUTINE GENNUM(text)
CHARACTER   text;	/* IN:  input string */
#else     /* ==== Generated Code === */
#define GENNUM	gennum_
GENNUM(va_alist) va_dcl 
{ va_list Cargs;
#endif    /* ======================= */
  int FORmark;           /* <forif> */

int ret;  va_start(Cargs);       /* <forif> */
  FORmark = ftoc_mark(); /* <forif> */

ret = CGN_NUMBER(STRIPPED_STRING(1,1,0));
ftoc_free(FORmark); /* <forif> */return(ret);
}

#if 0     /* ==== Original Code ==== */
SUBROUTINE GENLGN(infile,outfile,maxout)
CHARACTER   infile;	/* IN: input file name                  */
CHARACTER   outfile;	/* OUT: result file name                */
fint2c	*maxout;	/* IN: max length of outfile            */
#else     /* ==== Generated Code === */
#define GENLGN	genlgn_
GENLGN(va_alist) va_dcl 
{ va_list Cargs;
#endif    /* ======================= */
  int FORmark;           /* <forif> */

char *tmpfil;  va_start(Cargs);       /* <forif> */
  FORmark = ftoc_mark(); /* <forif> */

	
tmpfil = C_STRING(2,3,1);

CGN_LOGNAM(STRIPPED_STRING(1,3,0),tmpfil,(int)*PARAM(3,3,2,fint2c *));

STRFCOPY(2,3,1,tmpfil);
  ftoc_free(FORmark);    /* <forif> */
}

#if 0     /* ==== Original Code ==== */
SUBROUTINE GENTIM(time)
CHARACTER   time;	/* OUT: pointer to string of char containing the time */
#else     /* ==== Generated Code === */
#define GENTIM	gentim_
GENTIM(va_alist) va_dcl 
{ va_list Cargs;
#endif    /* ======================= */
  int FORmark;           /* <forif> */

char *mytime;  va_start(Cargs);       /* <forif> */
  FORmark = ftoc_mark(); /* <forif> */

mytime = C_STRING(1,1,0);
OSY_ASCTIM(mytime);
STRFCOPY(1,1,0,mytime);
  ftoc_free(FORmark);    /* <forif> */
}


