#define vmr	vmr_		/* parameter for Name Translation is l_ */
#define ROUTINE int
/*===========================================================================
  Copyright (C) 1995 European Southern Observatory (ESO)
 
  This program is free software; you can redistribute it and/or 
  modify it under the terms of the GNU General Public License as 
  published by the Free Software Foundation; either version 2 of 
  the License, or (at your option) any later version.
 
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public 
  License along with this program; if not, write to the Free 
  Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
  MA 02139, USA.
 
  Corresponding concerning ESO-MIDAS should be addressed as follows:
	Internet e-mail: midas@eso.org
	Postal address: European Southern Observatory
			Data Management Division 
			Karl-Schwarzschild-Strasse 2
			D 85748 Garching bei Muenchen 
			GERMANY
===========================================================================*/

/*++++++++++++++++++++++++  STC.FC +++++++++++++++++++++++++++++++++++++++
.LANGUAGE C
.IDENTIFICATION Module STC.FC
.COMMENTS
Module contains layer between the catalog related FORTRAN STxxxx interfaces
and the SC_interfaces written in (hopefully independent) C
.AUTHOR         K. Banse  	ESO - Garching
.KEYWORDS       standard interfaces.
.ENVIRONMENT    FORTRAN and C standards
.VERSION  [1.00] 880919:  created
.VERSION  [1.20] 881010:  add SZCSHO
.VERSION  [1.30] 890119:  updated
.VERSION  [1.40] 900219:  update parameters of SZCSHO
.VERSION  [3.00] 901213:  Master file. CG.
-----------------------------------------------------------------------------*/


#include <ftoc.h>
#include <midas_def.h>
	


static char savcatfile[200];
static int  savflag;

#if 0     /* ==== Original Code ==== */
SUBROUTINE STC1(catfile,flag)
CHARACTER   catfile;	/* IN: catalog file  */
fint2c	*flag;		/* IN: = 0 for name only. = 1 for name + ident */
#else     /* ==== Generated Code === */
#define STC1	stc1_
STC1(va_alist) va_dcl 
{ va_list Cargs;
#endif    /* ======================= */
  int FORmark;           /* <forif> */
  va_start(Cargs);       /* <forif> */
  FORmark = ftoc_mark(); /* <forif> */

strncpy(savcatfile,STRIPPED_STRING(1,2,0),199);
savcatfile[199] = '\0';

savflag = *PARAM(2,2,1,fint2c *);
  ftoc_free(FORmark);    /* <forif> */
}

#if 0     /* ==== Original Code ==== */
SUBROUTINE STCGT2(name,ident,no,status)
CHARACTER   name;	/* OUT: name of frame in next record of catalog */
CHARACTER   ident;	/* OUT: ident of that frame  */
fint2c	*no;		/* IN/OUT: current record no.  */
fint2c	*status;
#else     /* ==== Generated Code === */
#define STCGT2	stcgt2_
STCGT2(va_alist) va_dcl 
{ va_list Cargs;
#endif    /* ======================= */
  int FORmark;           /* <forif> */

char *myname, *myident;  va_start(Cargs);       /* <forif> */
  FORmark = ftoc_mark(); /* <forif> */


myname = C_STRING(1,4,0);
myident = C_STRING(2,4,1);

*PARAM(4,4,2,fint2c *) = SCCGET(savcatfile,savflag,myname,myident,PARAM(3,4,2,fint2c *));

STRFCOPY(1,4,0,myname);
STRFCOPY(2,4,1,myident);
  ftoc_free(FORmark);    /* <forif> */
}

#if 0     /* ==== Original Code ==== */
SUBROUTINE STCAD2(name,ident,status)
CHARACTER   name;	/* IN: name of frame to be added  */
CHARACTER   ident;	/* IN: IDENT info of frame to be added  */
fint2c	*status;
#else     /* ==== Generated Code === */
#define STCAD2	stcad2_
STCAD2(va_alist) va_dcl 
{ va_list Cargs;
#endif    /* ======================= */
  int FORmark;           /* <forif> */
  va_start(Cargs);       /* <forif> */
  FORmark = ftoc_mark(); /* <forif> */

*PARAM(3,3,2,fint2c *) = SCCADD(savcatfile,STRIPPED_STRING(1,3,0),STRIPPED_STRING(2,3,1));
  ftoc_free(FORmark);    /* <forif> */
}



