#define vmr	vmr_		/* parameter for Name Translation is l_ */
#define ROUTINE int
/*===========================================================================
  Copyright (C) 1995 European Southern Observatory (ESO)
 
  This program is free software; you can redistribute it and/or 
  modify it under the terms of the GNU General Public License as 
  published by the Free Software Foundation; either version 2 of 
  the License, or (at your option) any later version.
 
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public 
  License along with this program; if not, write to the Free 
  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
  MA 02139, USA.
 
  Correspondence concerning ESO-MIDAS should be addressed as follows:
	Internet e-mail: midas@eso.org
	Postal address: European Southern Observatory
			Data Management Division 
			Karl-Schwarzschild-Strasse 2
			D 85748 Garching bei Muenchen 
			GERMANY
===========================================================================*/

/*++++++++++++++++++++++++  STD.FC +++++++++++++++++++++++++++++++++++++++
.LANGUAGE C
.IDENTIFICATION Module STD.FC
.COMMENTS
Module contains layer between the descriptor related FORTRAN STxxxx interfaces
and the SC_interfaces written in (hopefully independent) C
.AUTHOR         K. Banse  	ESO - Garching
.KEYWORDS       standard interfaces.
.ENVIRONMENT    FORTRAN and C standards
.VERSION  [1.00] 871207:  created from SXFTOC.C

 011129		last modif

-----------------------------------------------------------------------------*/

#include <ftoc.h>
#include <midas_def.h>
	


static char savdsc[56];
static int  savno, savfelem, savnoelm;

static int  *pbytelem, *pnoelem, *phnc;

static int  dunit = 0, dnull = -1;

#if 0     /* ==== Original Code ==== */
SUBROUTINE STD1(no,descr,noelm,felem)
fint2c  *no;            /* IN : no. of data frame */
CHARACTER   descr;	/* IN : name of keyword  */
fint2c  *noelm;         /* IN : no. of "elements" in type, i.e. CHAR*noelm */
fint2c	*felem;		/* IN : first data item to be read */
#else     /* ==== Generated Code === */
#define STD1	std1_
STD1(va_alist) va_dcl 
{ va_list Cargs;
#endif    /* ======================= */
  int FORmark;           /* <forif> */
  va_start(Cargs);       /* <forif> */
  FORmark = ftoc_mark(); /* <forif> */
	
strncpy(savdsc,STRIPPED_STRING(2,4,0),50);
savdsc[50] = '\0';

savno = *PARAM(1,4,0,fint2c *);
savnoelm = *PARAM(3,4,1,fint2c *);
savfelem = *PARAM(4,4,1,fint2c *);
  ftoc_free(FORmark);    /* <forif> */
}

#if 0     /* ==== Original Code ==== */
SUBROUTINE STD2(bytelem,noelem,hnc)
fint2c  *bytelem;        /* OUT : no. of bytes per element */
fint2c  *noelem;         /* OUT : no. of elements */
fint2c  *hnc;            /* OUT : no. of help text chars */
#else     /* ==== Generated Code === */
#define STD2	std2_
STD2(va_alist) va_dcl 
{ va_list Cargs;
#endif    /* ======================= */
  va_start(Cargs);       /* <forif> */

pbytelem =PARAM(1,3,0,fint2c *);
pnoelem =PARAM(2,3,0,fint2c *);
phnc =PARAM(3,3,0,fint2c *);
}

#if 0     /* ==== Original Code ==== */
SUBROUTINE STDR2I(maxvals,actvals,values,status)
fint2c	*maxvals;	/* IN : max. vals to read */
fint2c	*actvals;	/* OUT: actual no. of elements returned */
fint2c  *values;	/* OUT: buffer for data values */
fint2c	*status;
#else     /* ==== Generated Code === */
#define STDR2I	stdr2i_
STDR2I(va_alist) va_dcl 
{ va_list Cargs;
#endif    /* ======================= */
  va_start(Cargs);       /* <forif> */
	
*PARAM(4,4,0,fint2c *) = SCDRDI(savno,savdsc,savfelem,*PARAM(1,4,0,fint2c *),PARAM(2,4,0,fint2c *),PARAM(3,4,0,fint2c *),
                 &dunit,&dnull);
}

#if 0     /* ==== Original Code ==== */
SUBROUTINE STDR2C(maxvals,actvals,values,status)
fint2c	*maxvals;	/* IN : max. vals to read */
fint2c  *actvals;	/* OUT: actual no. of elements returned */
CHARACTER  values;	/* OUT: buffer for data values */
fint2c	*status;
#else     /* ==== Generated Code === */
#define STDR2C	stdr2c_
STDR2C(va_alist) va_dcl 
{ va_list Cargs;
#endif    /* ======================= */
  int FORmark;           /* <forif> */
  va_start(Cargs);       /* <forif> */
  FORmark = ftoc_mark(); /* <forif> */
	
*PARAM(4,4,1,fint2c *) = SCDRDC(savno,savdsc,savnoelm,savfelem,
                 *PARAM(1,4,0,fint2c *),PARAM(2,4,0,fint2c *),CHAR_LOC(3,4,0),&dunit,&dnull);
  ftoc_free(FORmark);    /* <forif> */
}

#if 0     /* ==== Original Code ==== */
SUBROUTINE STDR2R(maxvals,actvals,values,status)
fint2c	*maxvals;	/* IN : max. vals to read */
fint2c	*actvals;	/* OUT: actual no. of elements returned */
float   *values;	/* OUT: buffer for data values */
fint2c	*status;
#else     /* ==== Generated Code === */
#define STDR2R	stdr2r_
STDR2R(va_alist) va_dcl 
{ va_list Cargs;
#endif    /* ======================= */
  va_start(Cargs);       /* <forif> */
	
*PARAM(4,4,0,fint2c *) = SCDRDR(savno,savdsc,savfelem,*PARAM(1,4,0,fint2c *),PARAM(2,4,0,fint2c *),PARAM(3,4,0,float *),
                 &dunit,&dnull);
}

#if 0     /* ==== Original Code ==== */
SUBROUTINE STDR2D(maxvals,actvals,values,status)
fint2c	*maxvals;	/* IN : max. vals to read */
fint2c	*actvals;	/* OUT: actual no. of elements returned */
double  *values;	/* OUT: buffer for data values */
fint2c	*status;
#else     /* ==== Generated Code === */
#define STDR2D	stdr2d_
STDR2D(va_alist) va_dcl 
{ va_list Cargs;
#endif    /* ======================= */
  va_start(Cargs);       /* <forif> */
	
*PARAM(4,4,0,fint2c *) = SCDRDD(savno,savdsc,savfelem,*PARAM(1,4,0,fint2c *),PARAM(2,4,0,fint2c *),PARAM(3,4,0,double *),
                 &dunit,&dnull);
}

#if 0     /* ==== Original Code ==== */
SUBROUTINE STDR2H(maxvals,actvals,values,total,status)
fint2c	*maxvals;	/* IN : max. vals to read */
fint2c    *actvals;       /* OUT: actual no. of values returned */
CHARACTER   values;     /* OUT: array for descriptor data */
fint2c    *total;         /* OUT: total size of help text*/
fint2c    *status;
#else     /* ==== Generated Code === */
#define STDR2H	stdr2h_
STDR2H(va_alist) va_dcl 
{ va_list Cargs;
#endif    /* ======================= */
  int FORmark;           /* <forif> */
  va_start(Cargs);       /* <forif> */
  FORmark = ftoc_mark(); /* <forif> */

*PARAM(5,5,1,fint2c *) = SCDRDH(savno,savdsc,savfelem,*PARAM(1,5,0,fint2c *),PARAM(2,5,0,fint2c *),
                 CHAR_LOC(3,5,0),PARAM(4,5,1,fint2c *));
  ftoc_free(FORmark);    /* <forif> */
}

#if 0     /* ==== Original Code ==== */
SUBROUTINE STDR2L(maxvals,actvals,values,status)
fint2c	*maxvals;	/* IN : max. vals to read */
fint2c	*actvals;	/* OUT: actual no. of elements returned */
fint2c  *values;	/* OUT: buffer for data values */
fint2c	*status;
#else     /* ==== Generated Code === */
#define STDR2L	stdr2l_
STDR2L(va_alist) va_dcl 
{ va_list Cargs;
#endif    /* ======================= */
	
int  dnull = -1;  va_start(Cargs);       /* <forif> */


*PARAM(4,4,0,fint2c *) = SCDRDL(savno,savdsc,savfelem,*PARAM(1,4,0,fint2c *),PARAM(2,4,0,fint2c *),PARAM(3,4,0,fint2c *),
                 &dunit,&dnull);
}

#if 0     /* ==== Original Code ==== */
SUBROUTINE STDFN2(type,noelem,bytelem,status)
CHARACTER   type;       /* OUT: type of descr - I, R, C, D or ' '   */
fint2c  *noelem;        /* OUT: no. of elements  */
fint2c  *bytelem;       /* OUT: no. of bytes per element  */
fint2c  *status;
#else     /* ==== Generated Code === */
#define STDFN2	stdfn2_
STDFN2(va_alist) va_dcl 
{ va_list Cargs;
#endif    /* ======================= */
  int FORmark;           /* <forif> */


/* CALL STD1(NO,DESCR,0,0) */  va_start(Cargs);       /* <forif> */
  FORmark = ftoc_mark(); /* <forif> */


*PARAM(4,4,1,fint2c *) = SCDFND(savno,savdsc,CHAR_LOC(1,4,0),PARAM(2,4,1,fint2c *),PARAM(3,4,1,fint2c *));
  ftoc_free(FORmark);    /* <forif> */
}

#if 0     /* ==== Original Code ==== */
SUBROUTINE STDIF2(field,buf,numbuf,status)
fint2c  *field;         /* IN: specify info,1 = NAME, 2 = TYPE, 3 = SIZE */
CHARACTER   buf;        /* IN : buffer for character descriptor info */
fint2c  *numbuf;        /* IN : return buffer for numerical data  */
fint2c  *status;
#else     /* ==== Generated Code === */
#define STDIF2	stdif2_
STDIF2(va_alist) va_dcl 
{ va_list Cargs;
#endif    /* ======================= */
  int FORmark;           /* <forif> */

int  nn;

char  tbuf[84];


/* CALL STD1(NO,'dummy',0,NPOS)  */  va_start(Cargs);       /* <forif> */
  FORmark = ftoc_mark(); /* <forif> */



nn = *PARAM(1,4,0,fint2c *); 
if (nn != 3)
   {
   memset((void *)tbuf,32,(size_t)80);
   *PARAM(4,4,1,fint2c *) = SCDINF(savno,savfelem,*PARAM(1,4,0,fint2c *),tbuf,79,PARAM(3,4,1,fint2c *));
   for (nn=0; nn<48; nn++)
      {
      if (tbuf[nn] == '\0')
         {
         tbuf[nn] = ' ';
         goto copy_it;
         }
      if (tbuf[nn] == ' ') goto copy_it;
      }
   nn = 47;

copy_it:
   (void) strncpy(CHAR_LOC(2,4,0),tbuf,nn+1);     /* have a blank in the end */
   }

else
   *PARAM(4,4,1,fint2c *) = SCDINF(savno,savfelem,3,tbuf,48,PARAM(3,4,1,fint2c *));
  ftoc_free(FORmark);    /* <forif> */

}

#if 0     /* ==== Original Code ==== */
SUBROUTINE STDRX2(descr,type,status)
CHARACTER   descr;      /* OUT : descriptor name */
CHARACTER   type;       /* OUT : descriptor type */
fint2c  *status;
#else     /* ==== Generated Code === */
#define STDRX2	stdrx2_
STDRX2(va_alist) va_dcl 
{ va_list Cargs;
#endif    /* ======================= */
  int FORmark;           /* <forif> */

int  nn;
char  tbuf[60];  va_start(Cargs);       /* <forif> */
  FORmark = ftoc_mark(); /* <forif> */


memset((void *)tbuf,32,(size_t)60);


/*  CALL STD1(NO,'dummy',0,FLAG)
    CALL STD2(BYTEL,NOEL,HNC)    */


*PARAM(3,3,2,fint2c *) = SCDRDX(savno,savfelem,tbuf,CHAR_LOC(2,3,1),pbytelem,pnoelem,phnc);

for (nn=0; nn<48; nn++)
   {
   if (tbuf[nn] == '\0')
      {
      tbuf[nn] = ' ';
      goto copy_it;
      }
   if (tbuf[nn] == ' ') goto copy_it;
   }
nn = 47;

copy_it:
(void) strncpy(CHAR_LOC(1,3,0),tbuf,nn+1);      /* have a blank in the end */
  ftoc_free(FORmark);    /* <forif> */
}

#if 0     /* ==== Original Code ==== */
SUBROUTINE STDW2C(maxvals,values,status)
fint2c	*maxvals;	/* IN : max. vals to read */
CHARACTER values;	/* IN : buffer with descriptor data */
fint2c	*status;
#else     /* ==== Generated Code === */
#define STDW2C	stdw2c_
STDW2C(va_alist) va_dcl 
{ va_list Cargs;
#endif    /* ======================= */
  int FORmark;           /* <forif> */
  va_start(Cargs);       /* <forif> */
  FORmark = ftoc_mark(); /* <forif> */
	
*PARAM(3,3,1,fint2c *) = SCDWRC(savno,savdsc,savnoelm,
          CHAR_LOC(2,3,0),savfelem,*PARAM(1,3,0,fint2c *),&dunit);
  ftoc_free(FORmark);    /* <forif> */
}

#if 0     /* ==== Original Code ==== */
SUBROUTINE STDW2D(maxvals,values,status)
fint2c	*maxvals;	/* IN : max. vals to read */
double	*values;	/* IN : buffer with descriptor data */
fint2c	*status;
#else     /* ==== Generated Code === */
#define STDW2D	stdw2d_
STDW2D(va_alist) va_dcl 
{ va_list Cargs;
#endif    /* ======================= */
  va_start(Cargs);       /* <forif> */
	
*PARAM(3,3,0,fint2c *) = SCDWRD(savno,savdsc,PARAM(2,3,0,double *),savfelem,*PARAM(1,3,0,fint2c *),&dunit);
}

#if 0     /* ==== Original Code ==== */
SUBROUTINE STDW2H(maxvals,values,status)
fint2c	*maxvals;	/* IN : max. vals to read */
CHARACTER   values;     /* IN : buffer with descriptor data */
fint2c    *status;
#else     /* ==== Generated Code === */
#define STDW2H	stdw2h_
STDW2H(va_alist) va_dcl 
{ va_list Cargs;
#endif    /* ======================= */
  int FORmark;           /* <forif> */
  va_start(Cargs);       /* <forif> */
  FORmark = ftoc_mark(); /* <forif> */

*PARAM(3,3,1,fint2c *) = SCDWRH(savno,savdsc,CHAR_LOC(2,3,0),savfelem,*PARAM(1,3,0,fint2c *));
  ftoc_free(FORmark);    /* <forif> */
}

#if 0     /* ==== Original Code ==== */
SUBROUTINE STDW2I(maxvals,values,status)
fint2c	*maxvals;	/* IN : max. vals to read */
fint2c	*values;	/* IN : buffer with descriptor data */
fint2c	*status;
#else     /* ==== Generated Code === */
#define STDW2I	stdw2i_
STDW2I(va_alist) va_dcl 
{ va_list Cargs;
#endif    /* ======================= */
  va_start(Cargs);       /* <forif> */
	
*PARAM(3,3,0,fint2c *) = SCDWRI(savno,savdsc,PARAM(2,3,0,fint2c *),savfelem,*PARAM(1,3,0,fint2c *),&dunit);
}

#if 0     /* ==== Original Code ==== */
SUBROUTINE STDW2L(maxvals,values,status)
fint2c	*maxvals;	/* IN : max. vals to read */
fint2c  *values;        /* IN : buffer with descriptor data */
fint2c  *status;
#else     /* ==== Generated Code === */
#define STDW2L	stdw2l_
STDW2L(va_alist) va_dcl 
{ va_list Cargs;
#endif    /* ======================= */
  va_start(Cargs);       /* <forif> */

*PARAM(3,3,0,fint2c *) = SCDWRL(savno,savdsc,PARAM(2,3,0,fint2c *),savfelem,*PARAM(1,3,0,fint2c *),&dunit);
}

#if 0     /* ==== Original Code ==== */
SUBROUTINE STDW2R(maxvals,values,status)
fint2c	*maxvals;	/* IN : max. vals to read */
float	*values;	/* IN : buffer with descriptor data */
fint2c	*status;
#else     /* ==== Generated Code === */
#define STDW2R	stdw2r_
STDW2R(va_alist) va_dcl 
{ va_list Cargs;
#endif    /* ======================= */
  va_start(Cargs);       /* <forif> */
	
*PARAM(3,3,0,fint2c *) = SCDWRR(savno,savdsc,PARAM(2,3,0,float *),savfelem,*PARAM(1,3,0,fint2c *),&dunit);
}
