#define vmr	vmr_		/* parameter for Name Translation is l_ */
#define ROUTINE int
/*===========================================================================
  Copyright (C) 1995 European Southern Observatory (ESO)
 
  This program is free software; you can redistribute it and/or 
  modify it under the terms of the GNU General Public License as 
  published by the Free Software Foundation; either version 2 of 
  the License, or (at your option) any later version.
 
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public 
  License along with this program; if not, write to the Free 
  Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
  MA 02139, USA.
 
  Corresponding concerning ESO-MIDAS should be addressed as follows:
	Internet e-mail: midas@eso.org
	Postal address: European Southern Observatory
			Data Management Division 
			Karl-Schwarzschild-Strasse 2
			D 85748 Garching bei Muenchen 
			GERMANY
===========================================================================*/

/*++++++++++++++++++++++++  STF.FC +++++++++++++++++++++++++++++++++++++++
.LANGUAGE C
.IDENTIFICATION Module STF.FC
.COMMENTS
Module contains layer between the frame related FORTRAN STxxxx interfaces
and the SC_interfaces written in (hopefully independent) C
.AUTHOR         K. Banse  	ESO - Garching
.KEYWORDS       standard interfaces.
.ENVIRONMENT    FORTRAN and C standards
.VERSION  [1.00] 871207:  created from SXFTOC.C
.VERSION  [2.60] 880415:  modified new version - the last one
.VERSION  [2.70] 890119:  add SZCFRNM
.VERSION  [2.80] 900316:  fix problem with FNAME_LEN+2 ...
.VERSION  [3.00] 901213:  Master file. CG.
-----------------------------------------------------------------------------*/

#include <ftoc.h>
#include <ftoc_comm.h>
#include <midas_def.h>

 

static char savname[200];
static int  savdattype, saviomode;

#if 0     /* ==== Original Code ==== */
SUBROUTINE STF1(name,dattype,iomode)
CHARACTER   name;	/* IN: name of data frame */
fint2c *dattype;	/* IN: data types as defined in Module header  */
fint2c *iomode;		/* IN: opening mode, e.g. F_O_MODE, ...   */
#else     /* ==== Generated Code === */
#define STF1	stf1_
STF1(va_alist) va_dcl 
{ va_list Cargs;
#endif    /* ======================= */
  int FORmark;           /* <forif> */
  va_start(Cargs);       /* <forif> */
  FORmark = ftoc_mark(); /* <forif> */

strncpy(savname,STRIPPED_STRING(1,3,0),199);
savname[199] = '\0';

savdattype = *PARAM(2,3,1,fint2c *);
saviomode = *PARAM(3,3,1,fint2c *);
  ftoc_free(FORmark);    /* <forif> */
}

#if 0     /* ==== Original Code ==== */
SUBROUTINE STFOP2(filtype,no,status)
fint2c *filtype;	/* IN: filetype, e.g. F_IMA_TYPE, ... */
fint2c *no;		/* OUT: file no. of the frame   */
fint2c *status;
#else     /* ==== Generated Code === */
#define STFOP2	stfop2_
STFOP2(va_alist) va_dcl 
{ va_list Cargs;
#endif    /* ======================= */

/* we have sent before newopn -> saviomode */  va_start(Cargs);       /* <forif> */


*PARAM(3,3,0,fint2c *) = SCFOPN(savname,savdattype,saviomode,*PARAM(1,3,0,fint2c *),PARAM(2,3,0,fint2c *));
}

#if 0     /* ==== Original Code ==== */
SUBROUTINE STFCR2(filtype,size,no,status)
fint2c *filtype;	/* IN: filetype no., e.g. F_TBL_TYPE, ... */
fint2c *size;		/* IN: size of object = no. of data values in file */
fint2c *no;		/* OUT: file no.  */
fint2c *status;
#else     /* ==== Generated Code === */
#define STFCR2	stfcr2_
STFCR2(va_alist) va_dcl 
{ va_list Cargs;
#endif    /* ======================= */
  va_start(Cargs);       /* <forif> */

*PARAM(4,4,0,fint2c *) = SCFCRE(savname,savdattype,saviomode,*PARAM(1,4,0,fint2c *),*PARAM(2,4,0,fint2c *),PARAM(3,4,0,fint2c *));
}

#if 0     /* ==== Original Code ==== */
SUBROUTINE STFXC2(filtype,size,optflags,no,status)
fint2c *filtype;                /* IN: filetype no., e.g. F_TBL_TYPE, ... */
fint2c *size;           /* IN: size of object = no. of data values in file */
fint2c *optflags;	/* IN: option for cloning descriptors;
			       = 0, NO (then same as SCFCRE)
			       = 1, Yes (optio(2) = imno of source frame) */
fint2c *no;             /* OUT: file no.  */
fint2c *status;
#else     /* ==== Generated Code === */
#define STFXC2	stfxc2_
STFXC2(va_alist) va_dcl 
{ va_list Cargs;
#endif    /* ======================= */
  va_start(Cargs);       /* <forif> */

*PARAM(5,5,0,fint2c *) = 
SCFXCR(savname,savdattype,saviomode,*PARAM(1,5,0,fint2c *),*PARAM(2,5,0,fint2c *),PARAM(3,5,0,fint2c *),PARAM(4,5,0,fint2c *));
}

#define STFMP2	stfmp2_
ROUTINE STFMP2(felem,size,actsize,pntr,status)
fint2c *felem;		/* IN : 1st pixel to be accessed in data space */
fint2c *size;		/* IN : number of data values (pixels) to be mapped */
fint2c *actsize;		/* OUT: actual no. of pixels mapped */
flong2c *pntr;		/* OUT: pointer to data in memory */
fint2c *status;
 
{
char *mypntr;

/* we have sent before: no -> savdattype */

*status = SCFMAP(savdattype,saviomode,*felem,*size,actsize,&mypntr);

*pntr = COMMON_INDEX(mypntr);
}
 
 

