#define vmr	vmr_		/* parameter for Name Translation is l_ */
#define ROUTINE int
/*===========================================================================
  Copyright (C) 1995 European Southern Observatory (ESO)
 
  This program is free software; you can redistribute it and/or 
  modify it under the terms of the GNU General Public License as 
  published by the Free Software Foundation; either version 2 of 
  the License, or (at your option) any later version.
 
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public 
  License along with this program; if not, write to the Free 
  Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
  MA 02139, USA.
 
  Corresponding concerning ESO-MIDAS should be addressed as follows:
	Internet e-mail: midas@eso.org
	Postal address: European Southern Observatory
			Data Management Division 
			Karl-Schwarzschild-Strasse 2
			D 85748 Garching bei Muenchen 
			GERMANY
===========================================================================*/

/*++++++++++++++++++++++++  STK.FC +++++++++++++++++++++++++++++++++++++++
.LANGUAGE C
.IDENTIFICATION Module STK.FC
.COMMENTS
Module contains layer between the keyword related FORTRAN STxxxx interfaces
and the SC_interfaces written in (hopefully independent) C
.AUTHOR         K. Banse  	ESO - Garching
.KEYWORDS       standard interfaces.
.ENVIRONMENT    FORTRAN and C standards
.VERSION  [1.00] 871207:  created from SXFTOC.C
.VERSION  [2.60] 880411:  modified new version - the last one
.VERSION  [2.70] 900316:  fix problems with TEXT_LEN+2
-----------------------------------------------------------------------------*/


#include <ftoc.h>
#include <midas_def.h>

static char savkey[24];
static int  savfelem, savmaxvals, savnoelm;

#if 0     /* ==== Original Code ==== */
SUBROUTINE STKR1(key,noelm,felem,maxvals)
CHARACTER   key;	/* IN : name of keyword  */
fint2c  *noelm;         /* IN : for char. arrays, CHAR*noelm - otherwise ignored */
fint2c	*felem;		/* IN : first data item to be read */
fint2c	*maxvals;	/* IN : no. of elements to get  */
#else     /* ==== Generated Code === */
#define STKR1	stkr1_
STKR1(va_alist) va_dcl 
{ va_list Cargs;
#endif    /* ======================= */
  int FORmark;           /* <forif> */
  va_start(Cargs);       /* <forif> */
  FORmark = ftoc_mark(); /* <forif> */
	
strncpy(savkey,STRIPPED_STRING(1,4,0),20);
savkey[20] = '\0';

savnoelm = *PARAM(2,4,1,fint2c *);
savfelem = *PARAM(3,4,1,fint2c *);
savmaxvals = *PARAM(4,4,1,fint2c *);
  ftoc_free(FORmark);    /* <forif> */
}

#if 0     /* ==== Original Code ==== */
SUBROUTINE STKR2I(actvals,values,status)
fint2c	*actvals;	/* OUT: actual no. of elements returned */
fint2c  *values;	/* OUT: buffer for data values */
fint2c	*status;
#else     /* ==== Generated Code === */
#define STKR2I	stkr2i_
STKR2I(va_alist) va_dcl 
{ va_list Cargs;
#endif    /* ======================= */
	
int  kunit = 0, knull = -1;  va_start(Cargs);       /* <forif> */


     *PARAM(3,3,0,fint2c *) = SCKRDI(savkey,savfelem,savmaxvals,PARAM(1,3,0,fint2c *),PARAM(2,3,0,fint2c *),&kunit,&knull);
}

#if 0     /* ==== Original Code ==== */
SUBROUTINE STKR2C(actvals,values,status)
fint2c  *actvals;	/* OUT: actual no. of elements returned */
CHARACTER  values;	/* OUT: buffer for data values */
fint2c	*status;
#else     /* ==== Generated Code === */
#define STKR2C	stkr2c_
STKR2C(va_alist) va_dcl 
{ va_list Cargs;
#endif    /* ======================= */
  int FORmark;           /* <forif> */
	
int  kunit = 0, knull = -1;  va_start(Cargs);       /* <forif> */
  FORmark = ftoc_mark(); /* <forif> */



     *PARAM(3,3,1,fint2c *) = SCKRDC(savkey,savnoelm,savfelem,
                      savmaxvals,PARAM(1,3,0,fint2c *),CHAR_LOC(2,3,0),&kunit,&knull);
  ftoc_free(FORmark);    /* <forif> */
}

#if 0     /* ==== Original Code ==== */
SUBROUTINE STKR2R(actvals,values,status)
fint2c	*actvals;	/* OUT: actual no. of elements returned */
float   *values;	/* OUT: buffer for data values */
fint2c	*status;
#else     /* ==== Generated Code === */
#define STKR2R	stkr2r_
STKR2R(va_alist) va_dcl 
{ va_list Cargs;
#endif    /* ======================= */
	
int  kunit = 0, knull = -1;  va_start(Cargs);       /* <forif> */


     *PARAM(3,3,0,fint2c *) = SCKRDR(savkey,savfelem,savmaxvals,PARAM(1,3,0,fint2c *),PARAM(2,3,0,float *),&kunit,&knull);
}

#if 0     /* ==== Original Code ==== */
SUBROUTINE STKR2D(actvals,values,status)
fint2c	*actvals;	/* OUT: actual no. of elements returned */
double  *values;	/* OUT: buffer for data values */
fint2c	*status;
#else     /* ==== Generated Code === */
#define STKR2D	stkr2d_
STKR2D(va_alist) va_dcl 
{ va_list Cargs;
#endif    /* ======================= */
	
int  kunit = 0, knull = -1;  va_start(Cargs);       /* <forif> */


     *PARAM(3,3,0,fint2c *) = SCKRDD(savkey,savfelem,savmaxvals,PARAM(1,3,0,fint2c *),PARAM(2,3,0,double *),&kunit,&knull);
}

#if 0     /* ==== Original Code ==== */
SUBROUTINE STKP2I(prompt,actvals,values,status)
CHARACTER   prompt;     /* IN : prompt string (null terminated) */
fint2c  *actvals;       /* OUT: actual no. of elements returned */
fint2c  *values;        /* OUT: buffer for data values */
fint2c  *status;
#else     /* ==== Generated Code === */
#define STKP2I	stkp2i_
STKP2I(va_alist) va_dcl 
{ va_list Cargs;
#endif    /* ======================= */
  int FORmark;           /* <forif> */

int  kunit = 0, knull = -1;  va_start(Cargs);       /* <forif> */
  FORmark = ftoc_mark(); /* <forif> */


     *PARAM(4,4,1,fint2c *) = SCKPRI(STRIPPED_STRING(1,4,0),savkey,
                      savfelem,savmaxvals,PARAM(2,4,1,fint2c *),PARAM(3,4,1,fint2c *),&kunit,&knull);
  ftoc_free(FORmark);    /* <forif> */
}

#if 0     /* ==== Original Code ==== */
SUBROUTINE STKP2C(prompt,actvals,values,status)
CHARACTER   prompt;     /* IN : prompt string (null terminated) */
fint2c  *actvals;       /* OUT: actual no. of elements returned */
CHARACTER  values;      /* OUT: buffer for data values */
fint2c  *status;
#else     /* ==== Generated Code === */
#define STKP2C	stkp2c_
STKP2C(va_alist) va_dcl 
{ va_list Cargs;
#endif    /* ======================= */
  int FORmark;           /* <forif> */

int  kunit = 0, knull = -1;  va_start(Cargs);       /* <forif> */
  FORmark = ftoc_mark(); /* <forif> */



     *PARAM(4,4,2,fint2c *) = SCKPRC(STRIPPED_STRING(1,4,0),savkey,savnoelm,savfelem,
                      savmaxvals,PARAM(2,4,1,fint2c *),CHAR_LOC(3,4,1),&kunit,&knull);
  ftoc_free(FORmark);    /* <forif> */
}

#if 0     /* ==== Original Code ==== */
SUBROUTINE STKP2R(prompt,actvals,values,status)
CHARACTER   prompt;     /* IN : prompt string (null terminated) */
fint2c  *actvals;       /* OUT: actual no. of elements returned */
float   *values;        /* OUT: buffer for data values */
fint2c  *status;
#else     /* ==== Generated Code === */
#define STKP2R	stkp2r_
STKP2R(va_alist) va_dcl 
{ va_list Cargs;
#endif    /* ======================= */
  int FORmark;           /* <forif> */

int  kunit = 0, knull = -1;  va_start(Cargs);       /* <forif> */
  FORmark = ftoc_mark(); /* <forif> */


     *PARAM(4,4,1,fint2c *) = SCKPRR(STRIPPED_STRING(1,4,0),savkey,savfelem,
                      savmaxvals,PARAM(2,4,1,fint2c *),PARAM(3,4,1,float *),&kunit,&knull);
  ftoc_free(FORmark);    /* <forif> */
}

#if 0     /* ==== Original Code ==== */
SUBROUTINE STKP2D(prompt,actvals,values,status)
CHARACTER   prompt;     /* IN : prompt string (null terminated) */
fint2c  *actvals;       /* OUT: actual no. of elements returned */
double  *values;        /* OUT: buffer for data values */
fint2c  *status;
#else     /* ==== Generated Code === */
#define STKP2D	stkp2d_
STKP2D(va_alist) va_dcl 
{ va_list Cargs;
#endif    /* ======================= */
  int FORmark;           /* <forif> */

int  kunit = 0, knull = -1;  va_start(Cargs);       /* <forif> */
  FORmark = ftoc_mark(); /* <forif> */


     *PARAM(4,4,1,fint2c *) = SCKPRD(STRIPPED_STRING(1,4,0),savkey,savfelem,
                      savmaxvals,PARAM(2,4,1,fint2c *),PARAM(3,4,1,double *),&kunit,&knull);
  ftoc_free(FORmark);    /* <forif> */
}

#if 0     /* ==== Original Code ==== */
SUBROUTINE STKW2C(values,status)
CHARACTER   values;	/* IN : buffer with data values */
fint2c	*status;
#else     /* ==== Generated Code === */
#define STKW2C	stkw2c_
STKW2C(va_alist) va_dcl 
{ va_list Cargs;
#endif    /* ======================= */
  int FORmark;           /* <forif> */
	
int  kunit = 0;  va_start(Cargs);       /* <forif> */
  FORmark = ftoc_mark(); /* <forif> */


    *PARAM(2,2,1,fint2c *) = SCKWRC(savkey,savnoelm,CHAR_LOC(1,2,0),
		     savfelem,savmaxvals,&kunit);
  ftoc_free(FORmark);    /* <forif> */
}

#if 0     /* ==== Original Code ==== */
SUBROUTINE STKW2D(values,status)
double	*values;	/* IN : buffer with data values */
fint2c  *status;
#else     /* ==== Generated Code === */
#define STKW2D	stkw2d_
STKW2D(va_alist) va_dcl 
{ va_list Cargs;
#endif    /* ======================= */

int  kunit = 0;  va_start(Cargs);       /* <forif> */


    *PARAM(2,2,0,fint2c *) = SCKWRD(savkey,PARAM(1,2,0,double *),savfelem,savmaxvals,&kunit);
}

#if 0     /* ==== Original Code ==== */
SUBROUTINE STKW2I(values,status)
fint2c	*values;	/* IN : buffer with data values */
fint2c  *status;
#else     /* ==== Generated Code === */
#define STKW2I	stkw2i_
STKW2I(va_alist) va_dcl 
{ va_list Cargs;
#endif    /* ======================= */

int  kunit = 0;  va_start(Cargs);       /* <forif> */


    *PARAM(2,2,0,fint2c *) = SCKWRI(savkey,PARAM(1,2,0,fint2c *),savfelem,savmaxvals,&kunit);
}

#if 0     /* ==== Original Code ==== */
SUBROUTINE STKW2R(values,status)
float	*values;	/* IN : buffer with data values */
fint2c  *status;
#else     /* ==== Generated Code === */
#define STKW2R	stkw2r_
STKW2R(va_alist) va_dcl 
{ va_list Cargs;
#endif    /* ======================= */

int  kunit = 0;  va_start(Cargs);       /* <forif> */


    *PARAM(2,2,0,fint2c *) = SCKWRR(savkey,PARAM(1,2,0,float *),savfelem,savmaxvals,&kunit);
}

