#define vmr	vmr_		/* parameter for Name Translation is l_ */
#define ROUTINE int
/*===========================================================================
  Copyright (C) 1995 European Southern Observatory (ESO)
 
  This program is free software; you can redistribute it and/or 
  modify it under the terms of the GNU General Public License as 
  published by the Free Software Foundation; either version 2 of 
  the License, or (at your option) any later version.
 
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public 
  License along with this program; if not, write to the Free 
  Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
  MA 02139, USA.
 
  Corresponding concerning ESO-MIDAS should be addressed as follows:
	Internet e-mail: midas@eso.org
	Postal address: European Southern Observatory
			Data Management Division 
			Karl-Schwarzschild-Strasse 2
			D 85748 Garching bei Muenchen 
			GERMANY
===========================================================================*/

/*++++++++++++++
.IDENTIFICATION tbc.fc
.LANGUAGE       C
.AUTHOR         J.D. Ponz, F. Ochsenbein (ESO-IPG))
.KEYWORDS       Table system, FORTRAN interface
.ENVIRONMENT    
.VERSION  1.0  	1 Feb 1987     Creation
.VERSION  1.1  	1 Dec 1987     Modification of the calling seq.
.VERSION  1.2  	7 Apr 1988     Add length to the calling seq.
.VERSION  1.3   16-Oct-1990: Simplified
.COMMENTS       FORTRAN 77 to C interface layer.
.               add TBCPAM MP feb 1992
---------------*/

#include <tbldef.h>
#include <ftoc.h>
#include <ftoc_comm.h>		/* VMR common */
#include <midas_def.h>

static char savbuf[104];
static int  savtid, *pin1, *pin2;

#if 0     /* ==== Original Code ==== */
SUBROUTINE TBC1(tid,buf,in1,in2)
fint2c  *tid;
CHARACTER   buf;
fint2c  *in1;
fint2c  *in2;
#else     /* ==== Generated Code === */
#define TBC1	tbc1_
TBC1(va_alist) va_dcl 
{ va_list Cargs;
#endif    /* ======================= */
  int FORmark;           /* <forif> */
  va_start(Cargs);       /* <forif> */
  FORmark = ftoc_mark(); /* <forif> */

strncpy(savbuf,STRIPPED_STRING(2,4,0),100);
savbuf[100] = '\0';

savtid = *PARAM(1,4,0,fint2c *);
pin1 =PARAM(3,4,1,fint2c *);
pin2 =PARAM(4,4,1,fint2c *);
  ftoc_free(FORmark);    /* <forif> */
}

#define TBCDEL	tbcdel_
ROUTINE TBCDEL(tid,col,ncol,status)
/*++++++++++++++++
.PURPOSE F77 to C interface used to delete a column in the table. 
.RETURNS -
-----------------*/
fint2c       *tid; 		/* IN : table identifier */
fint2c       *col;		/* IN : array with column numbers */
fint2c       *ncol;		/* OUT: number of columns */
fint2c       *status;		/* OUT: status return */
{
  *status = TCCDEL(*tid,*col,ncol);
}

#if 0     /* ==== Original Code ==== */
SUBROUTINE TBC2(tunit,label,col,status)
CHARACTER   tunit;		/* IN : column unit */
CHARACTER   label;		/* IN : column label */
fint2c       *col;		/* OUT: column number */
fint2c       *status;		/* OUT: status return */
#else     /* ==== Generated Code === */
#define TBC2	tbc2_
TBC2(va_alist) va_dcl 
{ va_list Cargs;
#endif    /* ======================= */
  int FORmark;           /* <forif> */

/* CALL TBC1(TID,FORM,DTYPE,ALEN) */  va_start(Cargs);       /* <forif> */
  FORmark = ftoc_mark(); /* <forif> */


*PARAM(4,4,2,fint2c *) = TCCINI(savtid,*pin1,*pin2,savbuf,
	STRIPPED_STRING(1,4,0),STRIPPED_STRING(2,4,1),PARAM(3,4,2,fint2c *));
  ftoc_free(FORmark);    /* <forif> */
}

#define TBCMAP	tbcmap_
ROUTINE TBCMAP(tid,col,indx,status)
/*++++++++++++++++
.PURPOSE F77 interface to map a table column.
.RETURNS -
-----------------*/
fint2c       *tid; 	/* IN : table identifier 	*/
fint2c       *col;	/* IN : column number 		*/
flong2c      *indx;	/* OUT: column address in VMR 	*/
fint2c       *status;	/* OUT: status return 		*/

{ 
char *mypntr;

*status = TCCMAP(*tid,*col,&mypntr);
*indx  = COMMON_INDEX(mypntr);	/* Convert to VMR index	*/
}

#define TBC3	tbc3_
ROUTINE TBC3(asked,mapped,indx,status)
fint2c       *asked;      /* IN : number of rows to be mapped */
fint2c       *mapped;     /* OUT: number of rows mapped   */
flong2c      *indx;	/* OUT: column address in VMR 	*/
fint2c       *status;	/* OUT: status return 		*/

{
char *mypntr;

/* CALL TBC1(TID,'dummy',COL,START) */

*status = TCCPAM(savtid,*pin1,*pin2,*asked,mapped,&mypntr);

*indx  = COMMON_INDEX(mypntr);
}

#if 0     /* ==== Original Code ==== */
SUBROUTINE TBC4(cols,flags,found_cols,status)
fint2c	   *cols;	/* OUT: Column numbers 			*/
fint2c	   *flags;	/* OUT: Column flags (bracketed numbers)*/ 
fint2c       *found_cols;	/* OUT: How many columns were found	*/
fint2c       *status;	/* OUT: status return */
#else     /* ==== Generated Code === */
#define TBC4	tbc4_
TBC4(va_alist) va_dcl 
{ va_list Cargs;
#endif    /* ======================= */


/* CALL TBC1(TID,TEXT,MAX_COLS,0) */  va_start(Cargs);       /* <forif> */


*PARAM(4,4,0,fint2c *) = TCCSEL(savtid,savbuf,*pin1,PARAM(1,4,0,fint2c *),PARAM(2,4,0,fint2c *),PARAM(3,4,0,fint2c *));
}

#if 0     /* ==== Original Code ==== */
SUBROUTINE TBCSER(tid,label,col,status)
/*++++++++++++++++
.PURPOSE F77 interface to search for a column in a table.
.RETURNS -
-----------------*/
fint2c       *tid; 		/* IN : table identifier */
CHARACTER   label;		/* IN : column reference */
fint2c       *col;		/* OUT: column number */
fint2c       *status;		/* OUT: status return */
#else     /* ==== Generated Code === */
#define TBCSER	tbcser_
TBCSER(va_alist) va_dcl 
{ va_list Cargs;
#endif    /* ======================= */
  int FORmark;           /* <forif> */
  va_start(Cargs);       /* <forif> */
  FORmark = ftoc_mark(); /* <forif> */

  *PARAM(4,4,1,fint2c *) = TCCSER(*PARAM(1,4,0,fint2c *),STRIPPED_STRING(2,4,0),PARAM(3,4,1,fint2c *));
  ftoc_free(FORmark);    /* <forif> */
}

#define TBCSRT	tbcsrt_
ROUTINE TBCSRT(tid,nc,col,sortfl,status)
/*++++++++++++++++
.PURPOSE F77 interface to sort a table.
.RETURNS -
-----------------*/
fint2c       *tid; 		/* IN : table identifier */
fint2c       *nc;			/* IN : number of columns */
fint2c       *col;		/* IN : array with column numbers */
fint2c       *sortfl;		/* IN : sort flag (up/down) */
fint2c       *status;		/* OUT: status return */
{
  *status = TCCSRT(*tid,*nc,col,sortfl);
}

#define TBCUNM	tbcunm_
ROUTINE TBCUNM(tid, indx, status)
/*++++++++++++++++
.PURPOSE F77 interface to TCCUNM (Unmap a Column)
.RETURNS -
-----------------*/
fint2c       *tid; 	/* IN : table identifier */
fint2c       *indx;	/* IN : Value returned by TBCMAP */
fint2c       *status;	/* OUT: status return */
{
  *status = TCCUNM(*tid, (char *)&((&vmr.addr)[*indx-1]));
}
